#CANNOT USE THIS BECAUSE OF A BUG IN THE 'DESTROY' IMPLEMENTATION!!
#Interpolation for variables does not work properly with 'destroy' 
#locals {
#  {{ containerName }}-docker-host-ip = "${data.terraform_remote_state.{{ appName }}.{{ dockerHostNodeName }}.external_ip_address}"
#}


{% if dockerPrivateRegistryIp and dockerPrivateRegistryPort and dockerPrivateRegistryUser and dockerPrivateRegistryPassword %}
resource "null_resource" "{{ imageName|replace("/", "-")  }}-{{ containerName }}" {
  provisioner "remote-exec" {
    inline = [
      "/tmp/scripts//registry-login-and-pull.sh ${trimspace(file("/app/{{ appName }}-{{ dockerHostNodeName }}-ip.txt"))}:8376 {{ dockerPrivateRegistryUser }} {{ dockerPrivateRegistryPassword }} {{ dockerPrivateRegistryIp }} {{ dockerPrivateRegistryPort }} {{ imageName }} {{ imageTag }}",
    ]
    connection {
      host = "${data.terraform_remote_state.{{ appName }}.{{ dockerHostNodeName }}.external_ip_address}"
      type     = "ssh"
      user     = "{{ vmUser }}"
      private_key =  "${file("/home/ubuntu/terraform/keypairs/{{ appName }}/private-key-openssh")}"
    }
  }

}
{% else %}


resource "docker_image" "{{ imageName|replace("/", "-") }}-{{ containerName }}" {
  provider = "docker.{{ dockerHostNodeName }}"
  name = "{{ imageName }}:{{ imageTag}}"
}
{% endif %}


resource "docker_container" "{{ containerName }}" {
  provider = "docker.{{ dockerHostNodeName }}"

{% if dockerPrivateRegistryIp and dockerPrivateRegistryPort and dockerPrivateRegistryUser and dockerPrivateRegistryPassword %}
  image =  "{{ dockerPrivateRegistryIp }}:{{ dockerPrivateRegistryPort }}/{{ imageName }}:{{ imageTag }}"
{% else  %}
  image =  "${docker_image.{{ imageName|replace("/", "-") }}-{{ containerName }}.latest}"
{% endif%}
  name  = "{{ containerName }}"
{% if entrypoint %}
  entrypoint = {{ entrypoint }}
{% endif %}
{% if command %}
  command = {{ command }}
{% endif %}
  hostname = "{{ hostname }}"
{% if restart %}
  restart = "{{ restart }}"
{% endif %}
{% if environment %}
  env = {{ environment }}
{% endif %}

{% if networks %}
  networks = [{{ '\"' + networks|join('\", \"') + '\"' }}]
{% endif %}

{% for port in portMapping %}
  ports {
    internal = {{ port['containerPort'] }}
    external = {{ port['hostPort'] }}
  }
{% endfor -%}

{% for volume in volumeMapping %}
  volumes {
  {% if volume['fromContainer'] %}
    from_container = "{{ volume['fromContainer'] }}"
  {% endif %}
  {% if volume['hostPath'] %}
    host_path = "{{ volume['hostPath'] }}"
  {% endif %}
  {% if volume['volumeName'] %}
    volume_name = "{{ volume['volumeName'] }}"
  {% endif %}
  {% if volume['containerPath'] %}
    container_path = "{{ volume['containerPath'] }}"
  {% endif %}
  {% if volume['readOnly'] %}
    read_only = "{{ volume['readOnly'] }}"
  {% endif %}
  }
{% endfor -%}

{% for host  in hostMapping %}
  host {
  {% if host['ip'] %}
    ip = "{{ host['ip'] }}",
  {% elif host['dockerHostNodeName'] %}
    ip = "${data.terraform_remote_state.{{ appName }}.{{ host['dockerHostNodeName'] }}.external_ip_address}",
  {% endif %}
    host = "{{ host['host'] }}"
  }
{% endfor %}
{% for capability in capabilities %}
  capabilities {
    add = "{{ capability['cap_add'] }}"
    drop = "{{ capability['cap_drop'] }}"
  }
{% endfor -%}
{% if dockerPrivateRegistryIp and dockerPrivateRegistryPort and dockerPrivateRegistryUser and dockerPrivateRegistryPassword %}
  depends_on = ["null_resource.{{ imageName|replace("/", "-")  }}-{{ containerName }}"]
{% endif %}

{% set depends_networks = [] %}
{% if networksDependencies %}
  depends_on = [{{ '\"' + networksDependencies|join('\", \"') + '\"' }}]
{% endif %}
}

{% if addConsulTraefikRules %}
resource "consul_keys" "{{ containerName }}" {
  count = "{{ addConsulTraefikRules }}"
  {% for endpoint in endpoints %}
  {% set serviceName = containerName %}
  {% if endpoint['containerNameOverride'] %}
  {%    set serviceName = endpoint['containerNameOverride'] %}
  {% endif %}
  key {
    name   = "{{ serviceName }}_entrypoints"
    path   = "{{ appName }}/traefik/frontends/{{ serviceName }}/entrypoints"
    value = "{{ endpoint['protocol'] }}"
    delete = true
  }
  key {
    name   = "{{ serviceName }}_url"
    path   = "{{ appName }}/traefik/backends/{{ serviceName }}/servers/server1/url"
    value = "{{ endpoint['protocol'] }}://${data.terraform_remote_state.{{ appName }}.{{ dockerHostNodeName }}.external_ip_address}:{{ endpoint['port'] }}"
    delete = true
  }
  key {
    name   = "{{ serviceName }}_address"
    path   = "{{ appName }}/traefik/backends/{{ serviceName }}/servers/server1/address"
    value = "${data.terraform_remote_state.{{ appName }}.{{ dockerHostNodeName }}.external_ip_address}"
    delete = true
  }
  key {
    name   = "{{ serviceName }}_port"
    path   = "{{ appName }}/traefik/backends/{{ serviceName }}/servers/server1/port"
    value = "{{ endpoint['port'] }}"
    delete = true
  }
  {% if not endpoint['skipRule'] %}
  key {
    name   = "{{ serviceName }}_rule"
    path   = "{{ appName }}/traefik/frontends/{{ serviceName }}/routes/test_1/rule"
    value  = "Host: {{ serviceName }}"
    delete = true
  }
  {% endif %}
  key {
    name   = "{{ serviceName }}_backend"
    path   = "{{ appName }}/traefik/frontends/{{ serviceName }}/backend"
    value  = "{{ serviceName }}"
    delete = true
  }
  {% endfor %}
}
{% endif %}

{% if addConsulService and consulServicePort %}
resource "consul_service" "{{ containerName }}" {
  count = "{{ addConsulService }}"
  address = "${data.terraform_remote_state.{{ appName }}.{{ dockerHostNodeName }}.external_ip_address}"
  name    = "{{ appName }}-{{ containerName }}"
  port    = "{{ consulServicePort }}"
  tags    = ["v1"]
}
{% endif %}

output "{{ containerName }}-ip" {
  value = "${data.terraform_remote_state.{{ appName }}.{{ dockerHostNodeName }}.external_ip_address}"
}

