terraform {
  backend "consul" {
    address = "{{ consulJoinIp }}:8500"
    path    = "{{ appName }}/services/terraform_state"
    datacenter = "dc1-aws"
  }
}


{% for dockerProvider in dockerProviders %}
provider "docker" {
  version = "~> 0.1"
  alias = "{{ dockerProvider }}"
  host = "${data.terraform_remote_state.{{ appName }}.{{ dockerProvider }}.external_ip_address}:8376"
  cert_path = "/home/ubuntu/terraform/certs/${data.terraform_remote_state.{{ appName }}.{{ dockerProvider }}.external_ip_address}/keys"
}
{% endfor %}

data "terraform_remote_state" "{{ appName }}" {
  backend = "consul"
  config {
    address = "{{ consulJoinIp }}:8500"
    path    = "{{ appName }}/infrastructure/terraform_state"
    datacenter = "dc1-aws"
  }
}


provider "consul" {
  version = "~> 1.0.0"
  address    = "{{ consulJoinIp }}:8500"
  datacenter = "dc1-aws"
}

